/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptationpoints.impl;

import edu.kit.ipd.descartes.core.Entity;

import edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage;
import edu.kit.ipd.descartes.mm.adaptationpoints.ModelEntityConfigurationRange;
import edu.kit.ipd.descartes.mm.adaptationpoints.VariationType;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Model Entity Configuration Range</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptationpoints.impl.ModelEntityConfigurationRangeImpl#getVariationPossibility <em>Variation Possibility</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptationpoints.impl.ModelEntityConfigurationRangeImpl#getAdaptableEntity <em>Adaptable Entity</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ModelEntityConfigurationRangeImpl extends AdaptationPointImpl implements ModelEntityConfigurationRange {
    /**
     * The cached value of the '{@link #getVariationPossibility() <em>Variation Possibility</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getVariationPossibility()
     * @generated
     * @ordered
     */
    protected VariationType variationPossibility;

    /**
     * The cached value of the '{@link #getAdaptableEntity() <em>Adaptable Entity</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getAdaptableEntity()
     * @generated
     * @ordered
     */
    protected Entity adaptableEntity;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ModelEntityConfigurationRangeImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return AdaptationpointsPackage.Literals.MODEL_ENTITY_CONFIGURATION_RANGE;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public VariationType getVariationPossibility() {
        return variationPossibility;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetVariationPossibility(VariationType newVariationPossibility, NotificationChain msgs) {
        VariationType oldVariationPossibility = variationPossibility;
        variationPossibility = newVariationPossibility;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdaptationpointsPackage.MODEL_ENTITY_CONFIGURATION_RANGE__VARIATION_POSSIBILITY, oldVariationPossibility, newVariationPossibility);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setVariationPossibility(VariationType newVariationPossibility) {
        if (newVariationPossibility != variationPossibility) {
            NotificationChain msgs = null;
            if (variationPossibility != null)
                msgs = ((InternalEObject)variationPossibility).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - AdaptationpointsPackage.MODEL_ENTITY_CONFIGURATION_RANGE__VARIATION_POSSIBILITY, null, msgs);
            if (newVariationPossibility != null)
                msgs = ((InternalEObject)newVariationPossibility).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - AdaptationpointsPackage.MODEL_ENTITY_CONFIGURATION_RANGE__VARIATION_POSSIBILITY, null, msgs);
            msgs = basicSetVariationPossibility(newVariationPossibility, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, AdaptationpointsPackage.MODEL_ENTITY_CONFIGURATION_RANGE__VARIATION_POSSIBILITY, newVariationPossibility, newVariationPossibility));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Entity getAdaptableEntity() {
        if (adaptableEntity != null && adaptableEntity.eIsProxy()) {
            InternalEObject oldAdaptableEntity = (InternalEObject)adaptableEntity;
            adaptableEntity = (Entity)eResolveProxy(oldAdaptableEntity);
            if (adaptableEntity != oldAdaptableEntity) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdaptationpointsPackage.MODEL_ENTITY_CONFIGURATION_RANGE__ADAPTABLE_ENTITY, oldAdaptableEntity, adaptableEntity));
            }
        }
        return adaptableEntity;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Entity basicGetAdaptableEntity() {
        return adaptableEntity;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setAdaptableEntity(Entity newAdaptableEntity) {
        Entity oldAdaptableEntity = adaptableEntity;
        adaptableEntity = newAdaptableEntity;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, AdaptationpointsPackage.MODEL_ENTITY_CONFIGURATION_RANGE__ADAPTABLE_ENTITY, oldAdaptableEntity, adaptableEntity));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case AdaptationpointsPackage.MODEL_ENTITY_CONFIGURATION_RANGE__VARIATION_POSSIBILITY:
                return basicSetVariationPossibility(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case AdaptationpointsPackage.MODEL_ENTITY_CONFIGURATION_RANGE__VARIATION_POSSIBILITY:
                return getVariationPossibility();
            case AdaptationpointsPackage.MODEL_ENTITY_CONFIGURATION_RANGE__ADAPTABLE_ENTITY:
                if (resolve) return getAdaptableEntity();
                return basicGetAdaptableEntity();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case AdaptationpointsPackage.MODEL_ENTITY_CONFIGURATION_RANGE__VARIATION_POSSIBILITY:
                setVariationPossibility((VariationType)newValue);
                return;
            case AdaptationpointsPackage.MODEL_ENTITY_CONFIGURATION_RANGE__ADAPTABLE_ENTITY:
                setAdaptableEntity((Entity)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case AdaptationpointsPackage.MODEL_ENTITY_CONFIGURATION_RANGE__VARIATION_POSSIBILITY:
                setVariationPossibility((VariationType)null);
                return;
            case AdaptationpointsPackage.MODEL_ENTITY_CONFIGURATION_RANGE__ADAPTABLE_ENTITY:
                setAdaptableEntity((Entity)null);
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case AdaptationpointsPackage.MODEL_ENTITY_CONFIGURATION_RANGE__VARIATION_POSSIBILITY:
                return variationPossibility != null;
            case AdaptationpointsPackage.MODEL_ENTITY_CONFIGURATION_RANGE__ADAPTABLE_ENTITY:
                return adaptableEntity != null;
        }
        return super.eIsSet(featureID);
    }

} //ModelEntityConfigurationRangeImpl
