/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.DataType;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.Parameter;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.Signature;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Call Parameter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter#getCharacterization <em>Characterization</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter#getSignature <em>Signature</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter#getParameter <em>Parameter</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter#getReturnType <em>Return Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getCallParameter()
 * @model abstract="true"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore constraints='EitherParameterOrReturnTypeOfSignatureReferenced'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot EitherParameterOrReturnTypeOfSignatureReferenced='\n\t\t\t(self.parameter.oclIsUndefined() implies (not self.returnType.oclIsUndefined() and self.signature.returnType = self.returnType)) and\n\t\t\t(self.returnType.oclIsUndefined() implies (not self.parameter.oclIsUndefined() and self.signature.parameters->includes(self.parameter)))'"
 * @generated
 */
public interface CallParameter extends InfluencingParameter {
	/**
	 * Returns the value of the '<em><b>Characterization</b></em>' attribute.
	 * The literals are from the enumeration {@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterCharacterizationType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Characterization</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Characterization</em>' attribute.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterCharacterizationType
	 * @see #setCharacterization(ParameterCharacterizationType)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getCallParameter_Characterization()
	 * @model required="true"
	 * @generated
	 */
	ParameterCharacterizationType getCharacterization();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter#getCharacterization <em>Characterization</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Characterization</em>' attribute.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterCharacterizationType
	 * @see #getCharacterization()
	 * @generated
	 */
	void setCharacterization(ParameterCharacterizationType value);

	/**
	 * Returns the value of the '<em><b>Signature</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Signature</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Signature</em>' reference.
	 * @see #setSignature(Signature)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getCallParameter_Signature()
	 * @model required="true"
	 * @generated
	 */
	Signature getSignature();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter#getSignature <em>Signature</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Signature</em>' reference.
	 * @see #getSignature()
	 * @generated
	 */
	void setSignature(Signature value);

	/**
	 * Returns the value of the '<em><b>Parameter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parameter</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parameter</em>' reference.
	 * @see #setParameter(Parameter)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getCallParameter_Parameter()
	 * @model
	 * @generated
	 */
	Parameter getParameter();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter#getParameter <em>Parameter</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parameter</em>' reference.
	 * @see #getParameter()
	 * @generated
	 */
	void setParameter(Parameter value);

	/**
	 * Returns the value of the '<em><b>Return Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Return Type</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Return Type</em>' reference.
	 * @see #setReturnType(DataType)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getCallParameter_ReturnType()
	 * @model
	 * @generated
	 */
	DataType getReturnType();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter#getReturnType <em>Return Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Return Type</em>' reference.
	 * @see #getReturnType()
	 * @generated
	 */
	void setReturnType(DataType value);

} // CallParameter
