/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Dependency Relationship</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyRelationship#getDependent <em>Dependent</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyRelationship#getIndependent <em>Independent</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getDependencyRelationship()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='DelegationOnlyAllowedWithSingleSource'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot DelegationOnlyAllowedWithSingleSource='\n\t\t\tself.characterization = RelationshipCharacterizationType::IDENTITY implies independent->size() = 1'"
 * @generated
 */
public interface DependencyRelationship extends Relationship {
	/**
	 * Returns the value of the '<em><b>Dependent</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dependent</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Dependent</em>' reference.
	 * @see #setDependent(InfluencedVariableReference)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getDependencyRelationship_Dependent()
	 * @model required="true"
	 * @generated
	 */
	InfluencedVariableReference getDependent();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyRelationship#getDependent <em>Dependent</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dependent</em>' reference.
	 * @see #getDependent()
	 * @generated
	 */
	void setDependent(InfluencedVariableReference value);

	/**
	 * Returns the value of the '<em><b>Independent</b></em>' reference list.
	 * The list contents are of type {@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencingParameter}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Independent</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Independent</em>' reference list.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getDependencyRelationship_Independent()
	 * @model required="true"
	 * @generated
	 */
	EList<InfluencingParameter> getIndependent();

} // DependencyRelationship
