/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.resourcelandscape;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapePackage
 * @generated
 */
public interface ResourcelandscapeFactory extends EFactory {
	/**
     * The singleton instance of the factory.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	ResourcelandscapeFactory eINSTANCE = edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapeFactoryImpl.init();

	/**
     * Returns a new object of class '<em>Computing Infrastructure</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Computing Infrastructure</em>'.
     * @generated
     */
	ComputingInfrastructure createComputingInfrastructure();

	/**
     * Returns a new object of class '<em>Networking Infrastructure</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Networking Infrastructure</em>'.
     * @generated
     */
	NetworkingInfrastructure createNetworkingInfrastructure();

	/**
     * Returns a new object of class '<em>Storage Infrastructure</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Storage Infrastructure</em>'.
     * @generated
     */
	StorageInfrastructure createStorageInfrastructure();

	/**
     * Returns a new object of class '<em>Runtime Environment</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Runtime Environment</em>'.
     * @generated
     */
	RuntimeEnvironment createRuntimeEnvironment();

	/**
     * Returns a new object of class '<em>Data Center</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Data Center</em>'.
     * @generated
     */
	DataCenter createDataCenter();

	/**
     * Returns a new object of class '<em>Distributed Data Center</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Distributed Data Center</em>'.
     * @generated
     */
	DistributedDataCenter createDistributedDataCenter();

	/**
     * Returns a new object of class '<em>Composite Hardware Infrastructure</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return a new object of class '<em>Composite Hardware Infrastructure</em>'.
     * @generated
     */
	CompositeHardwareInfrastructure createCompositeHardwareInfrastructure();

	/**
     * Returns the package supported by this factory.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the package supported by this factory.
     * @generated
     */
	ResourcelandscapePackage getResourcelandscapePackage();

} //ResourcelandscapeFactory
